Cantera 2.6.0

Classes | Macros | Functions
Error Handling

These classes and related functions are used to handle errors and unknown events within Cantera. More...

## Classes
class | CanteraError
| Base class for exceptions thrown by Cantera classes. More...
class | ArraySizeError
| Array size error. More...
class | IndexError
| An array index is out of range. More...

## Macros
#define | AssertTrace(expr) ((expr) ? (void) 0 : throw CanteraError(STR_TRACE, std::string("failed assert: ") + #expr))
| Assertion must be true or an error is thrown. More...
#define | AssertThrow(expr, procedure) ((expr) ? (void) 0 : throw CanteraError(procedure, std::string("failed assert: ") + #expr))
| Assertion must be true or an error is thrown. More...
#define | AssertThrowMsg(expr, procedure, ...) ((expr) ? (void) 0 : throw CanteraError(procedure + std::string(":\nfailed assert: \"") + std::string(#expr) + std::string("\""), __VA_ARGS__))
| Assertion must be true or an error is thrown. More...

## Functions
void | addError (const std::string &r, const std::string &msg="")
| Set an error condition in the application class without throwing an exception. More...
int | getErrorCount ()
| Return the number of errors that have been encountered so far. More...
void | popError ()
| Discard the last error message. More...
std::string | lastErrorMessage ()
| Retrieve the last error message in a string. More...
void | getErrors (std::ostream &f)
| Prints all of the error messages to an ostream. More...
void | logErrors ()
| Prints all of the error messages using writelog. More...

## Detailed Description

These classes and related functions are used to handle errors and unknown events within Cantera.

The general idea is that exceptions are thrown using the common base class called CanteraError. Derived types of CanteraError characterize what type of error is thrown. A list of all of the thrown errors is kept in the Application class.

Any exceptions which are not caught cause a fatal error exit from the program.

A group of defines may be used during debugging to assert conditions which should be true. These are named AssertTrace(), AssertThrow(), and AssertThrowMsg(). Examples of their usage is given below.

AssertTrace(p == OneAtm);
AssertThrow(p == OneAtm, "Kinetics::update");
AssertThrowMsg(p == OneAtm, "Kinetics::update",
"Algorithm limited to atmospheric pressure");
AssertThrow
#define AssertThrow(expr, procedure)
Assertion must be true or an error is thrown.
Definition: ctexceptions.h:254
AssertTrace
#define AssertTrace(expr)
Assertion must be true or an error is thrown.
Definition: ctexceptions.h:240
AssertThrowMsg
#define AssertThrowMsg(expr, procedure,...)
Assertion must be true or an error is thrown.
Definition: ctexceptions.h:271
Cantera::OneAtm
const double OneAtm
One atmosphere [Pa].
Definition: ct_defs.h:81

Their first argument is a boolean. If the boolean is not true, a CanteraError is thrown, with descriptive information indicating where the error occurred. The Assert* checks are skipped if the NDEBUG preprocessor symbol is defined, for example with the compiler option -DNDEBUG.

## Macro Definition Documentation

## ◆ AssertTrace

#define AssertTrace | ( |  | expr | ) | ((expr) ? (void) 0 : throw CanteraError(STR_TRACE, std::string("failed assert: ") + #expr))

Assertion must be true or an error is thrown.

Assertion must be true or else a CanteraError is thrown. A diagnostic string containing the file and line number, indicating where the error occurred is added to the thrown object.

Parameters

  expr | Boolean expression that must be true

Definition at line 240 of file ctexceptions.h.

## ◆ AssertThrow

#define AssertThrow | ( |  | expr,
|  |  | procedure
| ) |  | ((expr) ? (void) 0 : throw CanteraError(procedure, std::string("failed assert: ") + #expr))

Assertion must be true or an error is thrown.

Assertion must be true or else a CanteraError is thrown. A diagnostic string indicating where the error occurred is added to the thrown object.

Parameters

  expr | Boolean expression that must be true
  procedure | Character string or std:string expression indicating the procedure where the assertion failed

Definition at line 254 of file ctexceptions.h.

## ◆ AssertThrowMsg

#define AssertThrowMsg | ( |  | expr,
|  |  | procedure,
|  |  | ...
| ) |  | ((expr) ? (void) 0 : throw CanteraError(procedure + std::string(":\nfailed assert: \"") + std::string(#expr) + std::string("\""), __VA_ARGS__))

Assertion must be true or an error is thrown.

Assertion must be true or else a CanteraError is thrown. A diagnostic string indicating where the error occurred is added to the thrown object.

Parameters

  expr | Boolean expression that must be true
  procedure | Character string or std:string expression indicating the procedure where the assertion failed Additional arguments are passed on to the constructor for CanteraError to generate a formatted error message.

Definition at line 271 of file ctexceptions.h.

## Function Documentation

## ◆ addError()

void addError | ( | const std::string & | r,
|  | const std::string & | msg = `""`
| ) |  |

Set an error condition in the application class without throwing an exception.

This routine adds an error message to the end of the stack of errors that Cantera accumulates in the Application class.

Parameters

  r | Procedure name which is generating the error condition
  msg | Descriptive message of the error condition.

If only one argument is specified, that string is used as the entire message.

Definition at line 66 of file application.cpp.

Referenced by Application::addError().

## ◆ getErrorCount()

int getErrorCount | ( |  | ) |

Return the number of errors that have been encountered so far.

Definition at line 80 of file application.cpp.

Referenced by Application::getErrorCount().

## ◆ popError()

void popError | ( |  | ) |

Discard the last error message.

Cantera saves a stack of exceptions that it has caught in the Application class. This routine eliminates the last exception to be added to that stack.

Definition at line 300 of file application.cpp.

References Application::Messages::errorMessage.

Referenced by Application::popError().

## ◆ lastErrorMessage()

std::string lastErrorMessage | ( |  | ) |

Retrieve the last error message in a string.

This routine will retrieve the last error message and return it in the return string.

Definition at line 307 of file application.cpp.

Referenced by Application::lastErrorMessage().

## ◆ getErrors()

void getErrors | ( | std::ostream & | f | ) |

Prints all of the error messages to an ostream.

Write out all of the saved error messages to the ostream f using the function Logger::writelog. Cantera saves a stack of exceptions that it has caught in the Application class. This routine writes out all of the error messages to the ostream and then clears them from internal storage.

Parameters

  f | ostream which will receive the error messages

Definition at line 316 of file application.cpp.

Referenced by Application::getErrors().

## ◆ logErrors()

void logErrors | ( |  | ) |

Prints all of the error messages using writelog.

Print all of the error messages using function writelog. Cantera saves a stack of exceptions that it has caught in the Application class. This routine writes out all of the error messages and then clears them from internal storage.

Definition at line 324 of file application.cpp.

References Application::writelog(), and Application::writelogendl().

Referenced by Application::logErrors().